<?php

namespace Bbg\DotDatConverter\Helpers;

use Bbg\DotDatConverter\Entities\Schema;
use Bbg\DotDatConverter\Exceptions\InvalidSchemaException;

class SchemaValidator
{
    private bool $hasRecordSeparator = false;
    public static function validate(Schema $schema): bool
    {
        foreach ($schema->getSections() as $section) {
            /* @var \Bbg\DotDatConverter\Entities\Section $section */

            $sectionName = $section->getName();
            $position = 1;

            if($section->isRequired()){

            }

            foreach ($section->getFields() as $index => $field) {
                /* @var \Bbg\DotDatConverter\Entities\Field $field */
                $start = $field->getStart();
                $length = $field->getLength();;

                if($position === 1){
                    if (!$field->isRequired()) {
                        throw new InvalidSchemaException($sectionName . '.' . $field->getName() . ' needs to be marked as required');
                    }

                    if (!$field->hasDefault()) {
                        throw new InvalidSchemaException($sectionName . '.' . $field->getName() . '.start is empty');
                    }
                }

                if (empty($start)) {
                    throw new InvalidSchemaException($sectionName . '.' . $field->getName() . '.start is empty');
                }

                if (empty($length)) {
                    throw new InvalidSchemaException($sectionName . '.' . $field->getName() . '.length is empty');
                }

                if ($start !== $position) {
                    throw new InvalidSchemaException($sectionName . '.' . $field->getName() . '.start is invalid (' . $position . '/' . $start . ')');
                }

                $position += $length;
            }
        }

        return true;
    }
}