<?php

use Bbg\DotDatConverter\DotDatConverter;

chdir(__DIR__);

require '../vendor/autoload.php';

$test = new DotDatConverter('../schema/SalesOrder.json');

$record = $test->recordEncode([
    'File' => [
        'ClientId' => 123456789,
    ],
    'Header' => [
        'StoreId' => 123456789,
        'OrderId' => 2322111,
        'OrderReference' => 99887,
        'OrderType' => 'B2C',
        'OrderDate' => date('Y-m-d'),
        'CurrencyCode' => 'USD',
        'SoldToCustomerId' => 122334455,
        'ShipToCustomerId' => 122334455,
        'DistributionCenterId' => 34,

    ],
    'HeaderCustomAttributes' => [
        [
            'Name' => 'key1',
            'Value' => sha1(uniqid(microtime(true), true)),
        ],
        [
            'Name' => 'key2',
            'Value' => sha1(uniqid(microtime(true), true)),
        ],
        [
            'Name' => 'key3',
            'Value' => sha1(uniqid(microtime(true), true)),
        ],
    ],
    'HeaderGiftMessage' => [
        'GiftMessageFlag' => '1',
        'GiftWrapFlag' => '1',
        'GiftMessage' => 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.',
        'GiftWrapFee' => 5.39,
    ],
    'Detail' => [
        [
            'LineNumber' => 1000,
            'ItemNumber' => 401167,
            'ItemDescription' => 'Active Purifier',
            'UnitOfMeasure' => 'EACH',
            'Quantity' => 2,
        ],
        [
            'LineNumber' => 2000,
            'ItemNumber' => 401163,
            'ItemDescription' => 'Active Purifier',
            'UnitOfMeasure' => 'EACH',
            'Quantity' => 2,
        ],
        'childs' => [
            'DetailCustomAttributes' => [
                [
                    'Name' => 1000,
                    'Value' => 401167,
                ],
                [
                    'Name' => 2000,
                    'Value' => 401163,
                ],
            ],
        ]
    ],
    'ShipToInformation' => [
        'FirstName' => 'Daniel',
        'LastName' => 'Lichtenberg',
        'BusinessName' => 'Dr. Babor GmbH & Co. KG',
        'Address1' => 'Schefferstr. 17',
        'PostalCode' => 56316,
        'City' => 'Raubach',
        'State' => 'RLP',
        'Country' => 'DE',
        'Phone' => '+492684956636',
        'Email' => 'usshop01@netonme.de',
        'ShipMethod' => 'USPS-SURE',
    ],
    'EndOfFile' => [],
]);

file_put_contents('test.dat', $record);

echo $record;